<?php

namespace Andy\FeaturedThreads\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class FeaturedThreads extends Entity
{
    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_andy_featured_threads';
        $structure->shortName = 'Andy\FeaturedThreads:FeaturedThreads';
        $structure->primaryKey = 'featured_threads_id';
        $structure->columns = [
			'featured_threads_id' => ['type' => self::UINT, 'autoIncrement' => true, 'nullable' => true],
            'post_id' => ['type' => self::INT, 'default' => 0]
        
        ];
        $structure->getters = [];
		$structure->relations = [
			'Post' => [
				'entity' => 'XF:Post',
				'type' => self::TO_ONE,
				'conditions' => 'post_id',
				'primary' => true
			]
		];

        return $structure;
    }
}