<?php

namespace Andy\FeaturedThreads\Pub\Controller;

use XF\Pub\Controller\AbstractController;

class FeaturedThreads extends AbstractController
{
	public function actionIndex()
	{
		// get visitor
		$visitor = \XF::visitor();
		
		// get permission
		if (!$visitor->hasPermission('featuredThreads', 'admin'))
		{
			return $this->noPermission();
		}
		
		// get options
		$options = \XF::options();		
		
		// get options from Admin CP -> Options -> Featured threads -> Prefix ID
		$prefixId = $options->featuredThreadsPrefixId;
		

		// get results
		$finder = \XF::finder('XF:Thread');
		$threads = $finder
			->where('prefix_id', $prefixId)
			->order('post_date', 'DESC')
			->fetch();

		// get viewParams
		$viewParams = [
			'threads' => $threads
		];

		// send to template
		return $this->view('Andy\FeaturedThreads:Index', 'andy_featured_threads_list', $viewParams);
	}
}