<?php

namespace Andy\FeaturedThreads\XF\Cron;

class FeaturedThreads
{
	public static function runFeaturedThreads()
	{
		// get options
		$options = \XF::options();		
		
		// get options from Admin CP -> Options -> Featured threads -> Include forums
		$includeForums = $options->featuredThreadsIncludeForums;
		
		// get options from Admin CP -> Options -> Featured threads -> Prefix ID
		$prefixId = $options->featuredThreadsPrefixId;
		
		// get options from Admin CP -> Options -> Featured threads -> Days
		$days = $options->featuredThreadsDays;
		
		// get options from Admin CP -> Options -> Featured threads -> Limit
		$limit = $options->featuredThreadsLimit;
		
		// check condition
		if (empty($includeForums))
		{
			\XF::app()->error()->logError("Featured threads error. The options page Include forums requires forum selection.");
			return;
		}
        
		// check condition
		if ($includeForums[0] == 0)
		{
			\XF::app()->error()->logError("Featured threads error. The options page Include forums requires forum selection.");
			return;
		}
		
        // foreach condition
        foreach ($includeForums AS $value)
        {
            $conditions[] = ['Thread.node_id', '=', $value];
        }
        
        // check condition
        if ($days > 0)
        {
            $timestamp = time() - (86400 * $days);
        }
        else
        {
            $timestamp = 0;
        }

        // get results
        $finder = \XF::finder('Andy\FeaturedThreads:FeaturedThreads');
        $results = $finder
            ->fetch();

        // foreach condition
        foreach ($results AS $result)
        {
            $result->delete();
        }
		
		// check condition
		if ($prefixId == 0)
		{
			// get results
			$finder = \XF::finder('XF:Post');
			$results = $finder
				->where('position', 0)
				->where('message_state', 'visible')
				->where('Thread.discussion_state', 'visible')
				->where('user_id', '>', 0)
				->where('post_date', '>', $timestamp)
				->whereOr($conditions)
				->limit($limit)
				->order($finder->expression('RAND()'))
				->fetch();
		}
		
		// check condition
		if ($prefixId > 0)
		{
			// get results
			$finder = \XF::finder('XF:Post');
			$results = $finder
				->where('position', 0)
				->where('message_state', 'visible')
				->where('Thread.discussion_state', 'visible')
				->where('user_id', '>', 0)
				->where('post_date', '>', $timestamp)
				->where('Thread.prefix_id', $prefixId)
				->whereOr($conditions)
				->limit($limit)
				->order($finder->expression('RAND()'))
				->fetch();
		}
		
		// foreach condition
		foreach ($results as $value)
		{
			// save featuredThreads
			$featuredThreads = \XF::em()->create('Andy\FeaturedThreads:FeaturedThreads');
			$featuredThreads->post_id = $value->post_id;
			$featuredThreads->save();
		}
	}		
}